#ifndef SAFEARRAY5_H_
#define SAFEARRAY5_H_

class SafeArray
{
public:
    SafeArray()        : length(0),   elements(nullptr)         {}
    SafeArray(int len) : length(len), elements(new int[length]) {}

    virtual ~SafeArray() { if (elements != nullptr) delete[] elements; }

    int get_length() const { return length; }

    int at(int i) const;
    void set(int i, int value);

    SafeArray& operator =(const SafeArray& rhs);
    int& operator [](int i) const;

private:
    int length;
    int *elements;
};

#endif /* SAFEARRAY5_H_ */
